# NewsPro "Death By Chocolate" addon
# Version 1.3
# Date: 12/07/2000
# Written by: plushpuffin
# Original concept: KrYo
# Contact: kryo@tremor.se & plushpuffin@wwddfd.com
# See readme-fl.txt for disclaimers and copyrights.

&CheckBuild( 29, 'Death By Chocolate', 'npa_deathbychocolate.pl' );
push(@Addons_Loaded, 'Death By Chocolate 1.1');
push(@Addons_PageHandler, 'ChocolatePageHandler');
push(@Addons_NPHTMLHead_Head,'ChocolateHead');
push(@Addons_MainPage, 'Chocolate_MainPage');
push(@Addons_NPHTMLFoot, 'Chocolate_HTMLFoot');
push(@Addons_LoadHelp, 'Chocolate_LoadHelp');
$Addons_List{'Death By Chocolate 1.1'} = ['npa_deathbychocolate.pl', 'Delicious yet non-fattening. (A small percentage of people may have adverse reactions. The most common side effects were explosive diarrhea, bipolar disorder, immune system dysfunction, leprosy, mild nausea, and the clap.) by <a href="mailto:plushpuffin@wwddfd.com">plushpuffin</a>', ''];

##############################################
# Control access to the file path
#
$uMinEditLevel{'CSS'} = 1;
$gMinEditLevel{'CSS'} = 3;
#
##############################################

##############################################
# Define user information fields
#
$uField{'CSS'} = q~User CSS Style~;
$gField{'CSS'} = q~Inherited CSS Style~;

##############################################
# Make sure that the form elements
# are displayed on the User editing pages
#
push(@Addons_UGEditUser, q~CSSUGEdit~);
push(@Addons_UGEditGroup, q~CSSUGEdit~);

##############################################
# Ensure that properties are correctly
# formatted for storage and use
#
$ugSaveUser{'CSS'} = q~CSSUGCheckInput~;
$ugSaveGroup{'CSS'} = q~CSSUGCheckInput~;
#
##############################################

sub ChocolateLoadDefaults {
	return(
'.nptitle, .nptitle td, .nptitle font' => 'color: #008934; background: #000022',
'.npcontent, .npcontent td' => 'color: #aaaa11; background: #330000',
'.npfooter, .npfooter td' => 'background: #000024',
'.navbar' => 'color: #990000; font-size: 9pt; font-family: Courier, Palatino, serif',
'.navlink' => 'color: #00aa00; font-size: 9pt',
'body' => 'background: #000000',
'body p small font' => 'color: #00ff00',
'p' => 'color: #aaaa11; font-size: 10pt; font-family: Arial, Helvetica, sans-serif',
'.npcontent A' => 'color: #ffaa00',
'A:active' => 'color: #aaaa00',
'A:hover' => 'color: #11ffff; text-decoration: none'
	);
}

sub CSSUGEdit {
	my $cssdesc = $CPassword{$ug} ? $uField{'CSS'} : $gField{'CSS'};
	my $cssval = &ugVar( $ug, 'CSS' );
	$cssval =~ s~(.*).css~$1~;
	if( $up > 2 ) {
		print qq~<tr><td>
		$cssdesc<BR><BR>Choose the name of the file to use as your CSS file.<BR>
		<strong>DO NOT include the file extension ".css"</strong><BR>
		Current CSS file is $cssval</td><td>
		<input type="text" name="CSS" value="$cssval" size="70">
		</td></tr>
		~;
	}
	else {
		print qq~<tr><td>
		$cssdesc<BR><BR>Only webmasters may directly edit user CSS file names.<BR>
		Current CSS file is $cssval</td><td>
		$cssval
		</td></tr>
		~;
	}
}

sub CSSUGCheckInput {
	# Make sure that the user cannot specify relative directory paths.
	if( $up > 2 ) {
		$ugval =~ s~.*[/|^]([^/]+)$~$1~;
		if( $ugval && $ugval !~ /\.css$/i ) { $ugval .= '.css'; }
		return $ugval;
	}
	else {
		return &ugVar( $ug, 'CSS' );
	}
}

sub Chocolate_HTMLFoot {
	print qq~ <a href="$scripturl?chocolate" class="navlink">Death By Chocolate</a> |~;
}

sub Chocolate_MainPage {
	print qq~
	<b><a href="$scripturl?chocolate">Death By Chocolate</a>:</b> Better than sex. <a href="$scripturl?chocolate/settings">(edit settings)</a><br><br>
	~;
}

sub ChocolatePageHandler {
	&ugCheckBuild( 15, 'Death By Chocolate', 'npa_deathbychocolate.pl' );
	if( $qstring eq 'chocolate' ) {
		if( $NPConfig{'CSSdir'} && $NPConfig{'CSShref'} ) {
			&ChocolateMain;
		}
		else {
			&ChocolateSettings;
		}
	}
	elsif( $qstring eq 'chocolate/settings' ) {
		&ChocolateSettings;
	}
	elsif( $qstring eq 'chocolate/help' ) {
		&NPHTMLHead('Death By Chocolate : Help');
		&Chocolate_LoadHelp;
		print $Help{'chocolate'};
		&NPHTMLFoot;
		exit;
	}
}

sub ChocolateEscapeCSS {
	my ($a1,$a2,$a3,$a4) = ( $_[0], $_[1], $_[2], $_[3] );
	$a3 =~ s/\s*;\s*$//g;
	$a3 =~ s/\s*;\s*/\n/g;
	$a3 =~ s/\s*:\s*/: /g;
	return ( $a1 . $a2 . $a3 . $a4 );
}

sub ChocolateMain {
	$ug ||= $in{'dbcug'} || $Cookies{'uname'};
	$ug = ( $up > 2 ) ? $ug : $Cookies{'uname'};
	my $ugval = &ugVar( $ug, 'CSS' );
	my $whathappens = $in{'dbcclear'};
	my $cssval = $CPassword{$ug} ? &inheritedVar( $ug, 'CSS' ) : $ugval;
	my (@dbcss,%CStyles,$i,$key,$val,$keylines,$vallines,$keyexist);
	my $cssdesc = $CPassword{$ug} ? $uField{'CSS'} : $gField{'CSS'};
	$cssdesc .= qq~ : $ug~;
	my $cssexist = ( $cssval && -e "$NPConfig{'CSSdir'}/$cssval" && ! -d "$NPConfig{'CSSdir'}/$cssval" );
	unless( $ugval ) {
		( $ugval = "dbc_$ug" ) =~ s/\W//g;
		$ugval .= q~.css~;
	}
	&NPHTMLHead("Death By Chocolate : $cssdesc");
	print qq~<table cellspacing="0" cellpadding="20" align="center" border="1">
<tr><td align="center"><b>Helpful Links</b><BR>|
<a target="_blank" href="http://hotwired.lycos.com/webmonkey/authoring/stylesheets/">WebMonkey</a> |
<a target="_blank" href="http://www.users.interport.net/%7Egiant/COLOR/1ColorSpecifier.html">HYPE's Color Specifier</a> |
<a target="_blank" href="$scripturl?chocolate/help">Built-in HELP</a> |
</td></tr>
</table><BR>
	~;
	# test to see if this is a group CSS, not a user CSS
	$_ = ( $CPassword{$ug} && ! &ugVar( $ug, 'CSS' ) || ! $cssval );
	if( $_ && ! $in{'dbsub'} && ! $whathappens ) {
		print qq~
		<table width="50%" cellspacing="0" cellpadding="10" align="center">
		<tr><td align="center">
No CSS styles are set for $ug<BR>
Group CSS styles will be loaded.
		</td></tr>
		</table><BR>
		~;
		$cssval = $ugval;
		$cssexist = ( $cssval && -e "$NPConfig{'CSSdir'}/$cssval" && ! -d "$NPConfig{'CSSdir'}/$cssval" );
	}
	if( $whathappens  == 1 ) {
		print qq~
		<table width="50%" cellspacing="0" cellpadding="10" align="center">
		<tr><td align="center">
CSS style for $ug has been cleared<BR>
Group CSS styles will be loaded, if possible.
		</td></tr>
		</table><BR>
		~;
		&ugVarSetValue( $ug, 'CSS' );
		&UserGroupsSaveConfig;
		$cssval = &inheritedVar( $ug, 'CSS' );
		$cssexist = ( $cssval && -e "$NPConfig{'CSSdir'}/$cssval" && ! -d "$NPConfig{'CSSdir'}/$cssval" );
	}
	if( $whathappens == 2 || ( ! exists $in{"dbstyle--0"} && ! $cssexist ) ) {
		%CStyles = &ChocolateLoadDefaults;
		print qq~
		<table width="50%" cellspacing="0" cellpadding="10" align="center">
		<tr><td align="center">
The default CSS style has been loaded.<BR>
You must click <b>Apply CSS</b> to save this style.
		</td></tr>
		</table><BR>
		~;
	}
	if( $in{'dbsub'} && ! $whathappens ) {
		unless( &ugVar( $ug, 'CSS' ) ) {
			&ugVarSetValue( $ug, 'CSS', $ugval );
			&UserGroupsSaveConfig;
		}
		@dbcss = ();
		for( $i = 0; exists $in{"dbclass--$i"}; $i++ ) {
			$key = $in{"dbclass--$i"};
			$val = $in{"dbstyle--$i"};
			$key =~ s/^\s+$//gm;
			$val =~ s/^\s+$//gm;
			$key =~ s/\s*\n\s*/, /g;
			$val =~ s/\s*\n\s*/; /g;
			unless( ! $key || $key =~ /^new\d+$/i && ! $val ) {
				push( @dbcss, $key );
				$CStyles{$key} = $val;
			}
		}
		NPopen( CSS, ">$NPConfig{'CSSdir'}/$ugval" );
		foreach $key (@dbcss) {
			print CSS qq~$key { $CStyles{$key} }\n\n~;
		}
		close(CSS);
		print qq~
		<table width="50%" cellspacing="0" cellpadding="10" align="center">
		<tr><td align="center">
		$cssdesc saved<BR>
		<font size="-2">$NPConfig{'CSShref'}/$ugval<BR>
		$NPConfig{'CSSdir'}/$ugval</font><BR>
		You might have to <a href="$scripturl?chocolate">refresh</a> to see the changes.<BR>
		<font size="-2">(remember you cannot see the style in<BR>
		effect unless you are the user or group using the style)</font>
		</td></tr>
		</table><BR>
		~;
	}
	elsif( $cssexist && $whathappens != 2 ) {
		local $/ = q~}~;
		NPopen( CSS, "$NPConfig{'CSSdir'}/$cssval" );
		while( <CSS> ) {
			( $key, $val ) = $_ =~ m/\s*(.*\S+)\s*\{\s*(.*\S+)\s*}/s;
			unless( $key ) { next; }
			$CStyles{$key} = $val;
		}
		close(CSS);
	}
	@dbcss = sort keys %CStyles;
	print qq~<form action="$scripturl?chocolate" method="post">~;
	if( $up > 2 ) {
		print q~<table width="70%" cellspacing="0" cellpadding="10" align="center">
		<tr><td align="center" valign="middle"><font size="-1">
		<b>WebMasters Only:</b><BR>
		You may use this select box to edit a user's CSS
		or save the displayed values to a specific CSS.</font>
		</td><td align="center" valign="middle">
		<input type="submit" name="dbcch" value="Edit CSS File Of">
		<select name="dbcug">~;
		foreach $i ( sort keys %usergroups) {
			$key = $CPassword{$i} ? q~(user)~ : q~(group)~;
			$val = $ug eq $i ? q~ selected~ : q~~;
			print qq~<option value="$i"$val>$key : $i</option>~;
		}
		print q~</select></td></tr>
		</table><BR>~;
	}
	else {
		print qq~<h3>selected user: $ug</h3><BR><input type="hidden" name="dbcug" value="$ug">~;
	}
	print qq~<table align="center" border="2" cellspacing="2" cellpadding="5">
<tr>
	<td colspan="9" align="center">
		<input type="submit" name="dbsub" value="Apply CSS">
	</td>
</tr>~;
	$keyexist = 1;
	for( $i = 0; $i < @dbcss + 4; $i++ ) {
		$key = $dbcss[$i];
		unless( $key ) {
			$key = 'new';
			while( exists $CStyles{"new$keyexist"} ) {
				$keyexist++;
			}
			$key .= $keyexist;
			$CStyles{$key} = '';
		}
		$val = $CStyles{$key} || '';
		$val =~ s~\G(.*?)(\A|\))(.*?)(\Z|\()~ChocolateEscapeCSS($1,$2,$3,$4)~ges;
		$key =~ s/\s+/ /g;
		$key =~ s/\s*,\s*/\n/g;
		$keylines = 1 + scalar split( /\n/, $key );
		$vallines = 1 + scalar split( /\n/, $val );
		$keylines = $keylines < 7 ? $keylines : 6;
		$vallines = $vallines < 7 ? $vallines : 6;
		$keylines = $keylines > 1 ? $keylines : 2;
		$vallines = $vallines > 3 ? $vallines : 4;
		print qq~
<tr>
	<td>
		<textarea name="dbclass--$i" rows="$keylines" cols="20" wrap="virtual">$key</textarea>
	</td>
	<td width="100%">
		<textarea name="dbstyle--$i" rows="$vallines" cols="40" wrap="virtual" style="width:100%">$val</textarea>
	</td>
</tr>~;
	}
	print qq~
<tr>
	<td colspan="9" align="center">
		<input type="submit" name="dbsub" value="Apply CSS">
	</td>
</tr>
<tr>
	<td colspan="9" align="center"><BR><BR>
	Only choose &quot;Clear Personal Settings&quot; if you want to remove your CSS style.<BR>
	This will allow you to revert to the style defined by a group you belong to.<BR><BR>
	If you choose instead &quot;Load Default Settings&quot; then your personal CSS will<BR>
	be overridden with the defaults that plushpuffin hardcoded into Death By Chocolate.<BR>
	<BR>
	<input type="radio" name="dbcclear" value="0" checked><b>Save Personal Settings</b> (default)<BR>
	<input type="radio" name="dbcclear" value="1"><b>Clear Personal Settings</b><BR>
	<input type="radio" name="dbcclear" value="2"><b>Load Default Settings</b><BR>
	</td>
</tr>
	</table></form>
	<center>by <a href="mailto:plushpuffin\@wwddfd.com">plushpuffin</a><BR>
	<a href="http://www.wwddfd.com">plushpuffin's perl garden</a></center>~;
	&NPHTMLFoot;
	exit;
}

sub ChocolateSettings {
	&NPHTMLHead('Death By Chocolate: Settings');
	if( $up > 2 && $in{'CSSsaveset'} ) {
		print q~<div align="center">~;
		if( $in{'cssdir'} && $in{'csshref'} ) {
			$NPConfig{'CSSdir'} = $in{'cssdir'};
			$NPConfig{'CSShref'} = $in{'csshref'};
			&WriteConfigInfo;
			print q~
			Settings for Death By Chocolate have been saved.<BR>
			~;
		}
		print qq~
		<h3><a href="$scripturl">back to newspro</a><BR>
		<a href="$scripturl?chocolate">back to Death By Chocolate</a></h3>
		~;
	}
	elsif( $up > 2 ) {
		print qq~
		<form action="$scripturl?chocolate/settings" method="POST">
		<table cellspacing="5" cellpadding="10" align="center">
		~;
		print qq~<tr><td valign="middle"><font size="+1">Type the FULL PATH to the user/group CSS directory<BR>
		(no trailing slash)<BR><BR>
		</font>
		</td><td>
		<input type="text" size="60" name="cssdir" value="$NPConfig{'CSSdir'}">
		</tr>
		<tr><td valign="middle"><font size="+1">Type the FULL HREF to the user/group CSS directory<BR>
		(no trailing slash)<BR><BR>
		</font>
		</td><td>
		<input type="text" size="60" name="csshref" value="$NPConfig{'CSShref'}">
		</tr><tr>
		<td colspan="9" align="center">
		<input type="submit" name="CSSsaveset" value="Save DBC Settings">
		</td></tr>
		<tr><td align="center" colspan="9"><BR><HR>
		<center>by <a href="mailto:plushpuffin\@wwddfd.com">plushpuffin</a><BR>
		<a href="http://www.wwddfd.com">plushpuffin's perl garden</a></center>
		</td></tr>
		</table>
		</form>~;
	}
	else {
		unless( $NPConfig{'CSSdir'} && $NPConfig{'CSShref'} ) {
			print q~Death By Chocolate must be configured before use.<BR>~;
		}
		print q~You must have webmaster access to change settings for Death By Chocolate.~;
	}
	&NPHTMLFoot;
	exit;
}

sub ChocolateHead {
	unless($NPConfig{'BasicLayout'}) {
		&UGStartup;
		if( $UGV_CSS && $NPConfig{'CSShref'} ) {
		print qq~
		<link rel="stylesheet" type="text/css" href="$NPConfig{'CSShref'}/$UGV_CSS">
		~;
		}
	}
}


sub Chocolate_LoadHelp {
	if( $Help{'chocolate'} ) { return; }
	$Help{'chocolate'} = q~
<table width="100%" cellspacing="0" cellpadding="10" border="0">
<tr><td colspan="9">
Greetings. If you don't know any Cascading Style Sheets,
or if you're a tad rusty, this guide is here to walk you through it.
Here are the main things you need to know:
</td></tr>
<tr><td colspan="9">
<font size="+2">How CSS works</font>
</td></tr>
<tr><td width="200">
i { properties; }
</td><td>
set properties for all italic tags
</td></tr>
<tr><td width="200">
b, i { properties; }
</td><td>
set properties for all italic and bold tags
</td></tr>
<tr><td width="200">
b i { properties; }
</td><td>
set properties for only italic tags <i>inside</i> bold tags.
</td></tr>
<tr><td width="200">
p b i { properties; }
</td><td>
set properties for only italic tags <i>inside</i> bold tags
<i>inside</i> paragraph tags.
</td></tr>
<tr><td width="200">
.classname { properties; }
</td><td>
set properties for any tag labelled like so:<BR>
&lt;tag class=&quot;classname&quot;&gt;
</td></tr>

<tr><td colspan="9">
<font size="+2">CSS Size Units</font>
</td></tr>
<tr><td width="200">
pt
</td><td>
points. consistent, but not across platforms (Mac/PC/UNIX)
</td></tr>
<tr><td width="200">
px
</td><td>
points. consistent, but can't be printed or resized
</td></tr>
<tr><td width="200">
em
</td><td>
relative size. consistent, size relative to what it should be.<BR>
2em means twice normal. (note: nesting styles will multiply the em
values together, so 2em inside 5em will result in 10em)
</td></tr>
<tr><td width="200">
in, cm, mm
</td><td>
inches, centimeters, millimeters
</td></tr>
<tr><td width="200">
pc, ex
</td><td>
picas, x-height
</td></tr>

<tr><td colspan="9">
<font size="+2">CSS Text Properties</font>
</td></tr>
<tr><td width="200">
font-size
</td><td>
size of a font - smaller/larger and percentages not widely supported<BR>
font-size: 24pt;
font-size: smaller / larger;
font-size: xx-small / x-small / small / medium / large / x-large / xx-large;
</td></tr>
<tr><td width="200">
font-family
</td><td>
which font to use. if listed by commas, the browser will use the first valid choice.<BR>
font-family: "times new roman", helvetica, impact, serif;
</td></tr>
<tr><td width="200">
font-style
</td><td>
style of a font (italic/oblique/normal)<BR>
font-style: italic;
</td></tr>
<tr><td width="200">
font-weight
</td><td>
boldness of a font - can be numeric or bold or normal. numeric has a range from 100 to 900, with 400 being normal weight<BR>
font-weight: bold;<BR>
font-weight: 600;
</td></tr>
<tr><td width="200">
text-decoration
</td><td>
additional styling - underline / overline / line-through / blink / none<BR>
the stylings blink and overline are not widely supported by browsers<BR>
text-decoration: underline;
</td></tr>
<tr><td width="200">
text-transform
</td><td>
turn a section of text into all uppercase, all lowercase, first-letter-caps, or normal<BR>
valid options are uppercase / lowercase / capitalize / none<BR>
text-transform: uppercase;
</td></tr>
<tr><td width="200">
word-spacing
</td><td>
space between words - virtually unsupported by major browsers<BR>
word-spacing: 1.5em;
</td></tr>
<tr><td width="200">
letter-spacing
</td><td>
spacing between letters - fairly well supported<BR>
letter-spacing: 1.5em;
</td></tr>
<tr><td width="200">
line-height
</td><td>
distance between baselines of two lines of text - not supported in MSIE 3<BR>
line-height: 24pt;
</td></tr>
<tr><td width="200">
text-align
</td><td>
alignment of text - left / center / right /justify<BR>
text-align: left;
</td></tr>
<tr><td width="200">
vertical-align
</td><td>
vertical alignnment - top / bottom / text-top / text-bottom / baseline / middle / sub / super<BR>
almost completely unsupported in all browsers. do not use.<BR>
vertical-align: top;
</td></tr>
<tr><td width="200">
text-indent
</td><td>
indent first line of a paragraph<BR>
do not use negative values. IE 4/5 do not support it.<BR>
text-indent: 2em;
</td></tr>

<tr><td colspan="9">
<font size="+2">CSS Color &amp; Texture Properties</font>
</td></tr>
<tr><td width="200">
color
</td><td>
text color<BR>
color: #000000;
</td></tr>
<tr><td width="200">
background-color
</td><td>
background color of an element<BR>
background-color: #ffffff;<BR>
background-color: green;
</td></tr>
<tr><td width="200">
background-image
</td><td>
background texture<BR>
background-image: url(http://mysite.com/pict.jpg);
</td></tr>
<tr><td width="200">
background-repeat
</td><td>
background texture repeating<BR>
options available: no-repeat, repeat, repeat-x, repeat-y<BR>
background-repeat: repeat-x;
</td></tr>
<tr><td width="200">
background-attachment
</td><td>
background moves with the page or not. only applies to &lt;BODY&gt; tag<BR>
fixed is only supported in IE<BR>
background-attachment: scroll / fixed;
</td></tr>
<tr><td width="200">
background-position
</td><td>
offset of start of tiling<BR>
can use top, bottom, left, right, center, or length values.<BR>
background-position: 100px;
</td></tr>
<tr><td width="200">
background
</td><td>
shorthand for all the properties listed above<BR>
this method is preferred because MSIE 3 understands it.<BR>
background: url(http://mysite.com/pict.jpg) #ffffff repeat-y top left;
</td></tr>

<tr><td colspan="9">
<font size="+2">CSS Spacing Properties</font>
</td></tr>
<tr><td width="200">
margin-top<BR>margin-bottom<BR>margin-left<BR>margin-right
</td><td>
distance between the element and its border<BR>
use this in a surrounding &lt;DIV&gt; tag when dealing with images.<BR>
margin-top: 20px;
</td></tr>
<tr><td width="200">
padding-top<BR>padding-bottom<BR>padding-left<BR>padding-right
</td><td>
distance between the border and other elements<BR>
use this in a surrounding &lt;DIV&gt; tag when dealing with images.<BR>
padding-top: 20px;
</td></tr>
<tr><td width="200">
border-top-width<BR>border-bottom-width<BR>border-left-width<BR>border-right-width
</td><td>
thickness of the border<BR>
please specify a value for each side or IE 4/5 will get confused.<BR>
border-top-width: 5px;
</td></tr>
<tr><td width="200">
border-color
</td><td>
color of the border - use one value for all sides, or specify for each side<BR>
(( top right bottom left ))<BR>
border-color: #f0aa88;<BR>
border-color: #f0aa88 green #ffffff red;
</td></tr>
<tr><td width="200">
border-style
</td><td>
style of the border - use one value for all sides, or specify for each side<BR>
use values of solid, double, groove, ridge, inset, outset<BR>
values not supported by any browser: dotted, dashed<BR>
(( top right bottom left ))<BR>
border-color: solid;<BR>
border-color: solid groove solid double;
</td></tr>

<tr><td colspan="9">
<font size="+2">CSS Positioning Properties</font>
</td></tr>
<tr><td width="200">
float
</td><td>
make text or image float - everything wraps around it - left / center / right<BR>
float: left;
</td></tr>
<tr><td width="200">
clear
</td><td>
remove float property from a style<BR>
clear: left;
</td></tr>
<tr><td width="200">
position
</td><td>
position: absolute; - absolute positioning on the screen, from the top-left corner of the window<BR>
position: absolute; left: 100px; top: 100px;
</td></tr>
<tr><td width="200">
position
</td><td>
position: relative; - relative positioning on the screen, from where the element is supposed to be<BR>
position: relative; left: 100px; top: 100px;
</td></tr>
<tr><td width="200">
position
</td><td>
position: static; - normal positioning<BR>
position: static;
</td></tr>
<tr><td width="200">
clip
</td><td>
hide parts of an element.<BR>
auto = no clipping. negative values are allowed<BR>
clip: rect( 10px 200px 100px 40px );
</td></tr>
<tr><td width="200">
z-index
</td><td>
useful for layering elements. highest z-index shows on top<BR>
must be used on a &lt;DIV&gt; tag if used with images<BR>
z-index: 10;
</td></tr>

<tr><td colspan="9">
<font size="+2">How To Set Properties For CSS Links</font>
</td></tr>
<tr><td width="200">
A:link
</td><td>
a normal link<BR>
A:link { properties; }
</td></tr>
<tr><td width="200">
A:active
</td><td>
an active link (mouse clicking it)<BR>
A:active { properties; }
</td></tr>
<tr><td width="200">
A:visited
</td><td>
a visited link<BR>
A:visited { properties; }
</td></tr>
<tr><td width="200">
A:hover
</td><td>
a rollover link (mouse over it)<BR>
not supported in Netscape<BR>
A:hover { properties; }
</td></tr>

<tr><td colspan="9">
<font size="+2">A Few Examples</font>
</td></tr>
<tr><td width="200">
hover A HREF
</td><td>
A:hover { color: #000000; font-weight: normal; text-decoration: none; background: #FFFFFF }
</td></tr>
<tr><td width="200">
body style
</td><td>
BODY { background: url(http://www.wwddfd.com/gfx/moss.jpg) #2E8B57 repeat fixed top right; color: #CCCCFF }
</td></tr>
<tr><td width="200">
table cell style
</td><td>
td { background: url(http://www.wwddfd.com/gfx/cherry.jpg) #8B4513 repeat top left; color: #000000 }
</td></tr>
<tr><td width="200">
class &quot;.title&quot;
</td><td>
&lt;p class=&quot;title&quot;&gt;This Is The Title&lt;/p&gt;<BR>
.title { color: #000000; font-size: 32px; font-weight: bold; text-align: center; font-family: Arial, Helvetica, sans-serif }
</td></tr>

<tr><td colspan="9">
<font size="+2">A Few Rules To Follow</font>
</td></tr>
<tr><td width="200">
font-family
</td><td>
Always put font-family at the end. Some browsers will not use it otherwise.
</td></tr>
<tr><td width="200">
background
</td><td>
Always use background: instead of the other properties that it replaces.<BR>
MSIE 3 will not recognize the other properties.
</td></tr>
<tr><td width="200">
colors
</td><td>
Always use # in front of color values, unless you're using a name such as &quot;blue&quot;
</td></tr>
<tr><td width="200">
&lt;DIV&gt; tags
</td><td>
&lt;DIV&gt; tags can be very useful as: &lt;DIV class=&quot;imagealign&quot;&gt;&lt;IMG&gt;&lt;/DIV&gt;
</td></tr>
</table>
~;
}
1;